# PhasicFlow: src/Interaction/contactSearch/methods/cellBased/NBS/NBSLevel0Kernels.hpp File Reference
PhasicFlow is an open-source parallel DEM (discrete element method) package for simulating granular flow. It is developed in C++ and can be exectued on both GPU (like CUDA) and CPU.

NBSLevel0Kernels.hpp File Reference
Include dependency graph for NBSLevel0Kernels.hpp:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Namespaces

| pFlow
| pFlow::NBSLevel0Kernels

## Typedefs

using | mdrPolicyFindPairs = Kokkos::MDRangePolicy< Kokkos::IndexType< uint32 >, Kokkos::Rank< 3 >, Kokkos::Schedule< Kokkos::Dynamic >, DefaultExecutionSpace >

## Functions

template<typename T >
INLINE_FUNCTION_HD void | Swap (T &x, T &y)
INLINE_FUNCTION_HD bool | sphereSphereCheck (const realx3 &p1, const realx3 p2, real d1, real d2)
uint32 | findPairsCount (csPairContainerType &pairs, real sizeRatio, const deviceViewType1D< realx3 > &pointPos, const pFlagTypeDevice &flags, const deviceViewType1D< real > &diameter, mapperNBS::CellIterator cellIter)